diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/candidate-queue.h ns-3.47/src/internet/model/candidate-queue.h
--- ns-3.46/src/internet/model/candidate-queue.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/candidate-queue.h	2026-02-16 16:08:49.610230000 -0800
@@ -9,7 +9,10 @@
 #ifndef CANDIDATE_QUEUE_H
 #define CANDIDATE_QUEUE_H
 
+#include "global-route-manager.h"
+
 #include "ns3/ipv4-address.h"
+#include "ns3/ipv6-address.h"
 
 #include <list>
 #include <stdint.h>
@@ -17,8 +20,16 @@
 namespace ns3
 {
 
+template <typename T>
 class SPFVertex;
 
+template <typename>
+class CandidateQueue;
+
+// Forward declaration of operator<<
+template <typename T>
+std::ostream& operator<<(std::ostream& os, const CandidateQueue<T>& q);
+
 /**
  * @ingroup globalrouting
  *
@@ -38,8 +49,24 @@
  * requirement for a Reorder () operation led us to implement this simple
  * enhanced priority queue.
  */
+template <typename T>
 class CandidateQueue
 {
+    static_assert(std::is_same_v<T, Ipv4Manager> || std::is_same_v<T, Ipv6Manager>,
+                  "T must be either Ipv4Manager or Ipv6Manager when calling CandidateQueue");
+
+    /// Alias for determining whether the parent is Ipv4RoutingProtocol or Ipv6RoutingProtocol
+    static constexpr bool IsIpv4 = std::is_same_v<Ipv4Manager, T>;
+
+    /// Alias for Ipv4Manager and Ipv6Manager classes
+    using IpManager = typename std::conditional_t<IsIpv4, Ipv4Manager, Ipv6Manager>;
+
+    /// Alias for Ipv4 and Ipv6 classes
+    using Ip = typename std::conditional_t<IsIpv4, Ipv4, Ipv6>;
+
+    /// Alias for Ipv4Address and Ipv6Address classes
+    using IpAddress = typename std::conditional_t<IsIpv4, Ipv4Address, Ipv6Address>;
+
   public:
     /**
      * @brief Create an empty SPF Candidate Queue.
@@ -80,7 +107,7 @@
      * @see SPFVertex
      * @param vNew The Shortest Path First Vertex to add to the queue.
      */
-    void Push(SPFVertex* vNew);
+    void Push(SPFVertex<T>* vNew);
 
     /**
      * @brief Pop the Shortest Path First Vertex pointer at the top of the queue.
@@ -92,7 +119,7 @@
      * @see Top ()
      * @returns The Shortest Path First Vertex pointer at the top of the queue.
      */
-    SPFVertex* Pop();
+    SPFVertex<T>* Pop();
 
     /**
      * @brief Return the Shortest Path First Vertex pointer at the top of the
@@ -105,7 +132,7 @@
      * @see Pop ()
      * @returns The Shortest Path First Vertex pointer at the top of the queue.
      */
-    SPFVertex* Top() const;
+    SPFVertex<T>* Top() const;
 
     /**
      * @brief Test the Candidate Queue to determine if it is empty.
@@ -131,7 +158,7 @@
      * @param addr The IP address to search for.
      * @returns The SPFVertex* pointer corresponding to the given IP address.
      */
-    SPFVertex* Find(const Ipv4Address addr) const;
+    SPFVertex<T>* Find(const IpAddress addr) const;
 
     /**
      * @brief Reorders the Candidate Queue according to the priority scheme.
@@ -160,10 +187,10 @@
      * @param v2 second operand
      * @return True if v1 should be popped before v2; false otherwise
      */
-    static bool CompareSPFVertex(const SPFVertex* v1, const SPFVertex* v2);
+    static bool CompareSPFVertex(const SPFVertex<T>* v1, const SPFVertex<T>* v2);
 
-    typedef std::list<SPFVertex*> CandidateList_t; //!< container of SPFVertex pointers
-    CandidateList_t m_candidates;                  //!< SPFVertex candidates
+    typedef std::list<SPFVertex<T>*> CandidateList_t; //!< container of SPFVertex pointers
+    CandidateList_t m_candidates;                     //!< SPFVertex candidates
 
     /**
      * @brief Stream insertion operator.
@@ -172,7 +199,7 @@
      * @param q the CandidateQueue
      * @returns the reference to the output stream
      */
-    friend std::ostream& operator<<(std::ostream& os, const CandidateQueue& q);
+    friend std::ostream& operator<< <T>(std::ostream& os, const CandidateQueue& q);
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/global-route-manager.cc ns-3.47/src/internet/model/global-route-manager.cc
--- ns-3.46/src/internet/model/global-route-manager.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/global-route-manager.cc	2026-02-16 16:08:49.611230000 -0800
@@ -14,6 +14,8 @@
 #include "ns3/log.h"
 #include "ns3/simulation-singleton.h"
 
+#include <iomanip>
+
 namespace ns3
 {
 
@@ -25,40 +27,130 @@
 //
 // ---------------------------------------------------------------------------
 
-uint32_t GlobalRouteManager::routerId = 0;
+template <typename T>
+uint32_t GlobalRouteManager<T>::routerId = 0; //!< Router ID counter
 
+template <typename T>
 void
-GlobalRouteManager::DeleteGlobalRoutes()
+GlobalRouteManager<T>::DeleteGlobalRoutes()
 {
     NS_LOG_FUNCTION_NOARGS();
-    SimulationSingleton<GlobalRouteManagerImpl>::Get()->DeleteGlobalRoutes();
+    SimulationSingleton<GlobalRouteManagerImpl<typename GlobalRouteManager<T>::IpManager>>::Get()
+        ->DeleteGlobalRoutes();
 }
 
+template <typename T>
 void
-GlobalRouteManager::BuildGlobalRoutingDatabase()
+GlobalRouteManager<T>::BuildGlobalRoutingDatabase()
 {
     NS_LOG_FUNCTION_NOARGS();
-    SimulationSingleton<GlobalRouteManagerImpl>::Get()->BuildGlobalRoutingDatabase();
+    SimulationSingleton<GlobalRouteManagerImpl<typename GlobalRouteManager<T>::IpManager>>::Get()
+        ->BuildGlobalRoutingDatabase();
 }
 
+template <typename T>
 void
-GlobalRouteManager::InitializeRoutes()
+GlobalRouteManager<T>::InitializeRoutes()
 {
     NS_LOG_FUNCTION_NOARGS();
-    SimulationSingleton<GlobalRouteManagerImpl>::Get()->InitializeRoutes();
+    SimulationSingleton<GlobalRouteManagerImpl<typename GlobalRouteManager<T>::IpManager>>::Get()
+        ->InitializeRoutes();
 }
 
+template <typename T>
 uint32_t
-GlobalRouteManager::AllocateRouterId()
+GlobalRouteManager<T>::AllocateRouterId()
 {
     NS_LOG_FUNCTION_NOARGS();
     return routerId++;
 }
 
+template <typename T>
 void
-GlobalRouteManager::ResetRouterId()
+GlobalRouteManager<T>::ResetRouterId()
 {
     routerId = 0;
 }
 
+template <typename T>
+void
+GlobalRouteManager<T>::PrintRoute(Ptr<Node> sourceNode,
+                                  IpAddress dest,
+                                  Ptr<OutputStreamWrapper> stream,
+                                  bool nodeIdLookup,
+                                  Time::Unit unit)
+{
+    std::ostream* os = stream->GetStream();
+    // Copy the current ostream state
+    std::ios oldState(nullptr);
+    oldState.copyfmt(*os);
+
+    *os << std::resetiosflags(std::ios::adjustfield) << std::setiosflags(std::ios::left);
+    *os << "PrintRoute at Time: " << Now().As(unit);
+    *os << " from Node " << sourceNode->GetId() << " to address " << dest;
+    SimulationSingleton<GlobalRouteManagerImpl<IpManager>>::Get()->PrintRoute(sourceNode,
+                                                                              dest,
+                                                                              stream,
+                                                                              nodeIdLookup,
+                                                                              unit);
+    (*os).copyfmt(oldState);
+}
+
+template <typename T>
+void
+GlobalRouteManager<T>::PrintRoute(Ptr<Node> sourceNode,
+                                  IpAddress dest,
+                                  bool nodeIdLookup,
+                                  Time::Unit unit)
+{
+    Ptr<OutputStreamWrapper> stream = Create<OutputStreamWrapper>(&std::cout);
+    GlobalRouteManager<T>::PrintRoute(sourceNode, dest, stream, nodeIdLookup, unit);
+}
+
+template <typename T>
+void
+GlobalRouteManager<T>::PrintRoute(Ptr<Node> sourceNode,
+                                  Ptr<Node> dest,
+                                  Ptr<OutputStreamWrapper> stream,
+                                  bool nodeIdLookup,
+                                  Time::Unit unit)
+{
+    std::ostream* os = stream->GetStream();
+    // Copy the current ostream state
+    std::ios oldState(nullptr);
+    oldState.copyfmt(*os);
+
+    *os << std::resetiosflags(std::ios::adjustfield) << std::setiosflags(std::ios::left);
+    *os << "PrintRoute at Time: " << Now().As(unit);
+    *os << " from Node " << sourceNode->GetId() << " to Node " << dest->GetId();
+    SimulationSingleton<GlobalRouteManagerImpl<IpManager>>::Get()->PrintRoute(sourceNode,
+                                                                              dest,
+                                                                              stream,
+                                                                              nodeIdLookup,
+                                                                              unit);
+    (*os).copyfmt(oldState);
+}
+
+template <typename T>
+void
+GlobalRouteManager<T>::PrintRoute(Ptr<Node> sourceNode,
+                                  Ptr<Node> dest,
+                                  bool nodeIdLookup,
+                                  Time::Unit unit)
+{
+    Ptr<OutputStreamWrapper> stream = Create<OutputStreamWrapper>(&std::cout);
+    GlobalRouteManager<T>::PrintRoute(sourceNode, dest, stream, nodeIdLookup, unit);
+}
+
+template <typename T>
+void
+GlobalRouteManager<T>::InitializeRouters()
+{
+    SimulationSingleton<GlobalRouteManagerImpl<typename GlobalRouteManager<T>::IpManager>>::Get()
+        ->InitializeRouters();
+}
+
+template class ns3::GlobalRouteManager<ns3::Ipv4Manager>;
+template class ns3::GlobalRouteManager<ns3::Ipv6Manager>;
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/global-route-manager.h ns-3.47/src/internet/model/global-route-manager.h
--- ns-3.46/src/internet/model/global-route-manager.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/global-route-manager.h	2026-02-16 16:08:49.611230000 -0800
@@ -10,12 +10,31 @@
 #ifndef GLOBAL_ROUTE_MANAGER_H
 #define GLOBAL_ROUTE_MANAGER_H
 
+#include "ipv6.h"
+
+#include "ns3/ipv4-routing-helper.h"
+#include "ns3/ipv6-routing-helper.h"
+
 #include <cstdint>
 
 namespace ns3
 {
 
 /**
+ * Empty struct used as a template parameter
+ */
+struct Ipv4Manager
+{
+};
+
+/**
+ * Empty struct used as a template parameter
+ */
+struct Ipv6Manager
+{
+};
+
+/**
  * @ingroup globalrouting
  *
  * @brief A global global router
@@ -28,12 +47,28 @@
  *
  * The design is guided by OSPFv2 \RFC{2328} section 16.1.1 and quagga ospfd.
  */
+
+template <typename T>
 class GlobalRouteManager
 {
+    static_assert(std::is_same_v<T, Ipv4Manager> || std::is_same_v<T, Ipv6Manager>,
+                  "T must be either Ipv4Manager or Ipv6Manager when calling GlobalRouteManager");
+    /// Alias for determining whether the parent is Ipv4RoutingProtocol or Ipv6RoutingProtocol
+    static constexpr bool IsIpv4 = std::is_same_v<Ipv4Manager, T>;
+
+    /// Alias for Ipv4 and Ipv6 classes
+    using Ip = typename std::conditional_t<IsIpv4, Ipv4, Ipv6>;
+
+    /// Alias for Ipv4Address and Ipv6Address classes
+    using IpAddress = typename std::conditional_t<IsIpv4, Ipv4Address, Ipv6Address>;
+
+    /// Alias for Ipv4Manager and Ipv6Manager classes
+    using IpManager = typename std::conditional_t<IsIpv4, Ipv4Manager, Ipv6Manager>;
+
   public:
     // Delete copy constructor and assignment operator to avoid misuse
-    GlobalRouteManager(const GlobalRouteManager&) = delete;
-    GlobalRouteManager& operator=(const GlobalRouteManager&) = delete;
+    GlobalRouteManager(const GlobalRouteManager<T>&) = delete;
+    GlobalRouteManager& operator=(const GlobalRouteManager<T>&) = delete;
 
     /**
      * @brief Allocate a 32-bit router ID from monotonically increasing counter.
@@ -67,10 +102,78 @@
      */
     static void ResetRouterId();
 
+    /**
+     * @brief initialize all nodes as routers. this method queries all the nodes in the simulation
+     * and enables ipv6 forwarding on all of them.
+     */
+    static void InitializeRouters();
+
+    /**
+     * @brief prints the path from this node to the destination node at a particular time.
+     * @param sourceNode The source node.
+     * @param dest The IPv4 address of the destination node.
+     * @param stream The output stream to which the routing path will be written.
+     * @param nodeIdLookup Print the Node Id
+     * @param unit The time unit for timestamps in the printed output.
+     * @see Ipv4GlobalRoutingHelper::PrintRoute
+     */
+    static void PrintRoute(Ptr<Node> sourceNode,
+                           IpAddress dest,
+                           Ptr<OutputStreamWrapper> stream,
+                           bool nodeIdLookup = true,
+                           Time::Unit unit = Time::S);
+
+    /**
+     *@brief prints the path from this node to the destination node at a particular time.
+     * @param sourceNode The source node.
+     * @param dest The IP address of the destination node.
+     * @param nodeIdLookup Print the Node Id
+     * @param unit The time unit for timestamps in the printed output.
+     * @see Ipv4GlobalRoutingHelper::PrintRoute
+     */
+    static void PrintRoute(Ptr<Node> sourceNode,
+                           IpAddress dest,
+                           bool nodeIdLookup = true,
+                           Time::Unit unit = Time::S);
+
+    /**
+     *@brief prints the path from this node to the destination node at a particular time.
+     * @param sourceNode  The source node.
+     * @param dest The destination node.
+     * @param stream The output stream to which the routing path will be written.
+     * @param nodeIdLookup Print the Node Id
+     * @param unit The time unit for timestamps in the printed output.
+     * @see Ipv4GlobalRoutingHelper::PrintRoute
+     */
+    static void PrintRoute(Ptr<Node> sourceNode,
+                           Ptr<Node> dest,
+                           Ptr<OutputStreamWrapper> stream,
+                           bool nodeIdLookup = true,
+                           Time::Unit unit = Time::S);
+
+    /**
+     *@brief prints the path from this node to the destination node at a particular time.
+     * @param sourceNode The source node.
+     * @param dest The destination node.
+     * @param nodeIdLookup Print the Node Id
+     * @param unit The time unit for timestamps in the printed output.
+     * @see Ipv4GlobalRoutingHelper::PrintRoute
+     */
+    static void PrintRoute(Ptr<Node> sourceNode,
+                           Ptr<Node> dest,
+                           bool nodeIdLookup = true,
+                           Time::Unit unit = Time::S);
+
   private:
     static uint32_t routerId; //!< Router ID counter
 };
 
+/**
+ * @ingroup globalrouting
+ * Create the typedef Ipv4GlobalRouting with T as Ipv4RoutingProtocol
+ */
+typedef GlobalRouteManager<Ipv4Manager> Ipv4GlobalRouteManager;
+
 } // namespace ns3
 
 #endif /* GLOBAL_ROUTE_MANAGER_H */
